sonarqube-check:
  image: 
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script: 
    - sonar-scanner
  allow_failure: true
  rules:
    - if: $CI_COMMIT_BRANCH == 'master'


before_script:
  - docker info

stages:
  - build_image
  - deploy_image

build_image:
  stage: build_image
  script:
    - docker build . -t fastapi_test:$CI_PIPELINE_ID
    - echo  build Stage Completed and new tag is $CI_PIPELINE_ID
  rules:
    - if : '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "master"'  
deploy_image:
  stage: deploy_image
  script:
    - docker ps -q --filter "name=fastapi_container" | grep -q . && docker stop fastapi_container && docker rm -fv fastapi_container
    - echo stopped old container
    - docker run --rm -p 8085:8085 -d --name fastapi_container fastapi_test:$CI_PIPELINE_ID
    - echo deploy Stage Completed and new tag is $CI_PIPELINE_ID
  rules:
    - if : '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "master"'    
